package edu.mtech.esof427.keyboard;

public class CircleKey
{
    private Circle circle = null;
    private String character = "";
        
    public CircleKey(String data)
    {
        String cols [] = data.split(",");
        if (cols.length != 4)
            throw new RuntimeException("CircleKey constructor expects exactly 4 pieces of data!");
        
        this.character = cols[0];
        
        double x = Double.parseDouble(cols[1]);
        double y = Double.parseDouble(cols[2]);
        double r = Double.parseDouble(cols[3]);
        
        circle = new Circle(new Point(x, y), r);
    }
      
    public boolean isInside(Point point)
    {
        return circle.isInside(point);
    }

    public double getDistanceToCenter(Point point)
    {
        return circle.getDistanceToCenter(point);
    }
    
    public String getCharacter()
    {
        return character;
    }
        
}
