package edu.mtech.esof427.keyboard;

public class ComputeTraceFirst implements ComputeTrace
{
    @Override
    public Point getFocalPoint(Trace trace)
    {
        Touch touch = trace.get(0);
        
        if (touch instanceof TouchTime)
        {
            long minTime = Long.MAX_VALUE;
            Point minPoint = null;
            
            for (int i = 0; i < trace.size(); i++)
            {
                touch = trace.get(i);

                // If we have multitouch information, then we only count the 0-index finger
                if ((!(touch instanceof TouchFinger) ||
                    ((TouchFinger) touch).getFingerId() == 0))
                {
                    long time = ((TouchTime) touch).getTimeStampInMs();
                    if (time < minTime)
                    {
                        minTime = time;
                        minPoint = touch.getLocation();
                    }
                }                    
            }
            return minPoint;
        }
        else
        {
            // Without any timing information, we just use the first one
            return trace.get(0).getLocation();
        }
    }

}
