package edu.mtech.esof427.keyboard;

public class Point
{
    private double x = 0.0;
    private double y = 0.0;
    
    public Point(Point other)
    {
        this.x = other.x;
        this.y = other.y;
    }
    
    public Point(double x, double y)
    {
        this.x = x;
        this.y = y;
    }
    
    public double getX()
    {
        return x;
    }
    
    public double getY()
    {
        return y;
    }

    // Return the Euclidean distance between this point and the other point
    public double getDistance(Point other)
    {
        double deltaX = other.x - x;
        double deltaY = other.y - y;
        return Math.sqrt(deltaX * deltaX + deltaY * deltaY);
    }
    
    public String toString()
    {
        return String.format("(%.2f, %.2f)", x, y);
    }
}
