package edu.mtech.esof427.keyboard.test;

import static org.junit.Assert.*;

import org.junit.Test;

import edu.mtech.esof427.keyboard.ComputeTrace;
import edu.mtech.esof427.keyboard.ComputeTraceAvg;
import edu.mtech.esof427.keyboard.Point;
import edu.mtech.esof427.keyboard.ScreenOrientation;
import edu.mtech.esof427.keyboard.TouchTime;
import edu.mtech.esof427.keyboard.TraceOrientation;

public class ComputeTraceAvgTest
{
    private final static double EPSILON = 1e-10;

    @Test
    public void testGetFocalPointVerticalLine()
    {
        TraceOrientation trace = new TraceOrientation(ScreenOrientation.Portrait);        

        for (int i = -100; i <= 100; i++)
        {
            TouchTime time = new TouchTime(new Point(5.0, i), i + 1000);
            trace.add(time);
        }
        
        ComputeTrace compute = new ComputeTraceAvg();        
        Point focal = compute.getFocalPoint(trace);
        
        assertEquals(5.0, focal.getX(), EPSILON);
        assertEquals(0.0, focal.getY(), EPSILON);
    }

    @Test
    public void testGetFocalPointHorizontalLine()
    {
        TraceOrientation trace = new TraceOrientation(ScreenOrientation.Portrait);        

        for (int i = -100; i <= 100; i++)
        {
            TouchTime time = new TouchTime(new Point(i, 5.0), i + 1000);
            trace.add(time);
        }
        
        ComputeTrace compute = new ComputeTraceAvg();        
        Point focal = compute.getFocalPoint(trace);
        
        assertEquals(0.0, focal.getX(), EPSILON);
        assertEquals(5.0, focal.getY(), EPSILON);
    }
    
    @Test
    public void testGetFocalPointDiagonalLine()
    {
        TraceOrientation trace = new TraceOrientation(ScreenOrientation.Portrait);        

        for (int i = -100; i <= 100; i++)
        {
            TouchTime time = new TouchTime(new Point(i, i), i + 1000);
            trace.add(time);
        }
        
        ComputeTrace compute = new ComputeTraceAvg();        
        Point focal = compute.getFocalPoint(trace);
        
        assertEquals(0.0, focal.getX(), EPSILON);
        assertEquals(0.0, focal.getY(), EPSILON);
    }
           
}
