package edu.mtech.esof427.keyboard.test;

import static org.junit.Assert.*;

import org.junit.Test;

import edu.mtech.esof427.keyboard.Point;
import edu.mtech.esof427.keyboard.TouchFinger;

public class TouchFingerTest
{
   private final static double EPSILON = 1e-8;
    
    @Test
    public void testToString()
    {
        TouchFinger finger = new TouchFinger(new Point(1.0, 2.0), 12345, 0);
        
        String str = finger.toString();
        assertTrue(str.length() > 0);
    }

    @Test
    public void testGetTime()
    {
        TouchFinger finger = new TouchFinger(new Point(1.0, 2.0), 12345, 0);
        assertEquals(12345, finger.getTimeStampInMs());
    }
    
    @Test
    public void testGetLocation()
    {
        TouchFinger finger = new TouchFinger(new Point(1.0, 2.0), 12345, 0);
        Point location = finger.getLocation();
        
        assertEquals(1.0, location.getX(), EPSILON);
        assertEquals(2.0, location.getY(), EPSILON);        
    }
    
    @Test
    public void testFingerId()
    {
        TouchFinger finger = new TouchFinger(new Point(1.0, 2.0), 12345, 0);
        assertEquals(0, finger.getFingerId());
    }

}
