package edu.mtech.esof427.keyboard.test;

import static org.junit.Assert.*;
import org.junit.Test;
import edu.mtech.esof427.keyboard.*;
import java.io.*;

public class TraceSequenceTest
{   
    private static final String TRACE1 = "mobile643.txt";
    private static final String TRACE2 = "mobile1329.txt";    
    private static final String TRACE_FINGER = "mobile140_finger.txt";

    @Test
    public void testTrace1() throws IOException
    {
        TraceSequence sequence = new TraceSequence(TRACE1, 0);
        assertEquals(12, sequence.size());
    }

    @Test
    public void testTrace2() throws IOException
    {
        TraceSequence sequence = new TraceSequence(TRACE2, 0);
        assertEquals(31, sequence.size());
    }

    @Test
    public void testTraceFinger() throws IOException
    {
        TraceSequence sequence = new TraceSequence(TRACE_FINGER, 1);
        assertEquals(18, sequence.size());
    }

    // Try and load a file without finger IDs with a flag saying the file has them
    @Test(expected = RuntimeException.class)
    public void testTraceFingerInvalid() throws IOException
    {
        TraceSequence sequence = new TraceSequence(TRACE1, 1);
    }

    // Try and load a file with finger IDs with a flag saying the file does not have them
    @Test(expected = RuntimeException.class)
    public void testTraceInvalid() throws IOException
    {
        TraceSequence sequence = new TraceSequence(TRACE_FINGER, 0);
    }

}
